unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Winapi.ShlObj;

type
  TXMLTestForm = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  XMLTestForm: TXMLTestForm;

implementation

{$R *.dfm}

uses XML.XMLIniFile, XML.XMLIntf, XML.XMLDoc, System.UITypes;

const
  INIFOLDERNAME = 'XMLiniTEST';       // init@CptH_[ ̃AvP[VƂԂȂlɐݒ肵܂B
                                      // ʏ́AvŐ҂̖OAЖՂOɂ܂B
  EXTENSION     = '.xml';             // Xml `̃t@CȂ̂Ŋgq xmlɐݒ Ɋgq͖̐̂iniłłǂB

{ XyVz_[̎擾 }
function GetPath(Second: integer): string;
var
  PATH: Array[0..MAX_PATH - 1] of char;                       // pX擾pz
begin
  if SHGetSpecialFolderPath(Application.Handle, PATH, Second, False)    // XyVz_[pX擾
      then Result := PATH                                               // AlPath Zbg
      else Result := '';                                                // 擾oȂ "" Zbg
end;

{ CjVt@C̏ }
{ CSIDL_APPDATA ́A[U[p̃f[^[tH_[ C:\Users\Username\AppData\Roaming@
                                                  "C:\Documents and Settings\username\Local Settings\Application Data"
  CSIDL_LOCAL_APPDATA gpC:\Users\Username\AppData\Local 擾
  AllUserpɊݒt@C쐬ꍇ
  CSIDL_COMMON_APPDATA gpA                  C:\Users\All users\\AppData\Local 擾
                                                  "C:\Documents and Settings\All Users\Application Data"
  ̃tH_[ɂɃAvP[VptH_[݂̒ɁAݒpA f[^[pt@C쐬܂B
  ZLeBÃtH_[̓[U[ŃvOォ玩RɏݓǂݏoƂotH_[ł}
procedure TXMLTestForm.Button1Click(Sender: TObject);
var
  Root : IXMLDocument;
  SettingsXML: TXMLIniFile;
  RootTag : string;
  IniFolder: string;
  SaveFolder: string;
begin
//  IniFolder := GetPath(CSIDL_LOCAL_APPDATA);                            // [U[f[^[tH_[̎擾
  IniFolder := GetPath(CSIDL_APPDATA);                                  // [U[f[^[tH_[̎擾
  if IniFolder = '' then exit;                                          // 擾łȂI
  IniFolder := IniFolder + '\' + INIFOLDERNAME;                         // init@CptH_[Zbg
  if not DirectoryExists(IniFolder) then
    begin                                                               // iniptH_[쐬B
      if not CreateDir(IniFolder) then                                  // iniptH_[̍쐬
        begin
          MessageDlg('tH_[̍쐬Ɏs܂B',mtInformation,[mbOk],0);
          exit;
        end;
    end;
  SaveFolder := ExtractFilePath(Application.ExeName);                   // PɎst@C̃tH_[擾

  RootTag := ExtractFileName(ChangeFileExt(Application.ExeName, ''));   // t@C擪^bOeLXgpɎst@Co
  self.Caption := RootTag;                                              // PɊmFpɃtH[ɕ\ύXӖ͂Ȃ
  Root :=  NewXMLDocument();                                            //  XML hLgTXMLDocument IuWFNg쐬
  Root.AddChild(RootTag);                                               // XMLt@C̃[g EXE t@C^OZbg@
  Root.Options := [doNodeAutoIndent];                                   // I[gCfgON

  Root.Active := True;                                                  // Active  True ɂȂƏ܂Ȃ
  SettingsXML := TXmlIniFile.Create(Root.DocumentElement);              // TXmlIniFileCX^X

  try
    SettingsXML.WriteInteger('Form', 'Width' , Self.Width);
    SettingsXML.WriteInteger('Form', 'Height', Self.Height);

    SettingsXML.WriteString('Path', 'ExeFileFolder', SaveFolder);

    Root.SaveToFile(IniFolder + '\' + ExtractFileName(ChangeFileExt(Application.ExeName, EXTENSION)));  // ݎs

  finally
    SettingsXML.Free;
  end;
end;

procedure TXMLTestForm.Button2Click(Sender: TObject);
var
  Root : IXMLDocument;
  SettingsXML: TXMLIniFile;
  IniFolder: string;
begin
  IniFolder := GetPath(CSIDL_APPDATA) + '\' + INIFOLDERNAME;            // init@CptH_[Zbg CSIDL_LOCAL_APPDATA
  IniFolder := IniFolder + '\' + ExtractFileName(ChangeFileExt(Application.ExeName, EXTENSION));   // tpXinit@CZbg
  if not FileExists(IniFolder) then exit;                               // init@CI
  Root := LoadXMLDocument(IniFolder);                                   // ǂݍރt@CwTXMLDocument IuWFNg쐬

  Root.Active := True;                                                  // ftHgTrueł邪Ô TruełłȂƓǂݍ߂Ȃ
  SettingsXML := TXmlIniFile.Create(Root.DocumentElement);              // TXmlIniFileCX^X

  try
    self.Height :=  SettingsXML.ReadInteger('Form', 'Height' , 500);
    self.Width  :=  SettingsXML.ReadInteger('Form', 'Width', 800);

    self.Caption := SettingsXML.ReadString('Path', 'ExeFileFolder', 'C:\TEMP');
  finally
    SettingsXML.Free;
  end;
end;

end.
